package com.loafle.overflow.commons.exception;

import io.grpc.Status;

public class OverflowException extends Exception {
    protected Status.Code code;

    public OverflowException(Status.Code code) {
        super();
        this.code = code;
    }

    public OverflowException(Status.Code code, String message) {
        super(message);
        this.code = code;
    }

    public Status.Code getCode() {
        return code;
    }
}
