package com.loafle.overflow.module.sensor.dao;


import com.loafle.overflow.module.probe.model.Probe;
import com.loafle.overflow.module.sensor.model.Sensor;
import com.loafle.overflow.module.target.model.Target;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * Created by root on 17. 6. 9.
 */
@Repository
public interface SensorDAO extends JpaRepository<Sensor, Long> {
    List<Sensor> findAllByTarget(Target target);

    List<Sensor> findAllByTarget(List<Target> targetList);
//    List<Sensor> findAllByTargetList(List<Target> targets);
}
