package com.loafle.overflow.module.target.service;

import com.loafle.overflow.module.discovery.model.Host;
import com.loafle.overflow.module.discovery.model.Port;
import com.loafle.overflow.module.discovery.type.PortType;
import com.loafle.overflow.module.infra.dao.*;
import com.loafle.overflow.module.infra.model.*;
import com.loafle.overflow.module.meta.model.MetaInfraVendor;
import com.loafle.overflow.module.probe.model.Probe;
import com.loafle.overflow.module.target.dao.TargetDAO;
import com.loafle.overflow.module.target.model.Target;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.transaction.Transactional;
import java.util.List;

/**
 * Created by snoop on 17. 6. 28.
 */
@Service("TargetDiscoveryService")
public class TargetDiscoveryService {

    @Autowired
    private TargetDAO targetDAO;

    @Autowired
    private InfraMachineDAO infraMachineDAO;

    @Autowired
    private InfraOSDAO infraOSDAO;

    @Autowired
    private InfraHostDAO infraHostDAO;

    @Autowired
    private InfraDAO infraDAO;

    @Autowired
    private InfraOSPortDAO infraOSPortDAO;

    @Autowired
    private InfraServiceDAO infraServiceDAO;

//    @Transactional
//    public void saveAllTarget(List<Host> hosts, Probe probe) {
//
//        for(Host host : hosts) {
//
//            InfraMachine infraMachine = new InfraMachine();
////            infraMachine.setProbe(probe);
//            this.infraMachineDAO.save(infraMachine);
//
//            Infra infraByMachine = Infra.CreateInfraByType(infraMachine.getId(), InfraMachine.class);
//            this.infraDAO.save(infraByMachine);
//
//
//            InfraOS infraOS = new InfraOS();
////            infraOS.setMachine(infraMachine);
////            infraOS.setVendor(MetaInfraVendor.CreateInfraVendorByOS(host.getOs()));
//            this.infraOSDAO.save(infraOS);
//
//            Infra infraByOS = Infra.CreateInfraByType(infraOS.getId(), InfraOS.class);
//            this.infraDAO.save(infraByOS);
//
//
//            InfraHost infraHost = new InfraHost();
//            infraHost.setIp(host.getIp());
//            infraHost.setMac(host.getMac());
////            infraHost.setOs(infraOS);
//            this.infraHostDAO.save(infraHost);
//
//            Infra infraByHost = Infra.CreateInfraByType(infraHost.getId(), InfraHost.class);
//            this.infraDAO.save(infraByHost);
//
//            if(host.isTarget()) {
//                Target targetHost = new Target();
////                targetHost.setInfra(infraByHost);
////                targetHost.setProbe(probe);
//                this.targetDAO.save(targetHost);
//            }
//
//            if(host.getPorts() == null) {
//                continue;
//            }
//
//            for(Port port : host.getPorts()) {
//
//                InfraOSPort infraOSPort = new InfraOSPort();
//                infraOSPort.setOs(infraOS);
//                infraOSPort.setPort(port.getPortNumber());
//                infraOSPort.setPortType("UDP");
//                if(port.getPortType() == PortType.TLS || port.getPortType() == PortType.TCP) {
//                    infraOSPort.setPortType("TCP");
//                }
//                if (port.getPortType() == PortType.TLS) {
//                    infraOSPort.setTlsType(true);
//                }
//                infraOSPort.setVendor(MetaInfraVendor.CreateInfraVendorByPort(port.getPortNumber()));
//                this.infraOSPortDAO.save(infraOSPort);
//
//                Infra infraByPort = Infra.CreateInfraByType(infraOSPort.getId(), InfraOSPort.class);
//                this.infraDAO.save(infraByPort);
//
//                if(port.getServices() == null) {
//                    continue;
//                }
//
//                for(com.loafle.overflow.module.discovery.model.Service service : port.getServices()) {
//
//                    InfraService infraService = new InfraService();
//                    infraService.setHost(infraHost);
//                    infraService.setPort(port.getPortNumber());
//                    infraService.setPortType("UDP");
//                    if(port.getPortType() == PortType.TLS || port.getPortType() == PortType.TCP) {
//                        infraService.setPortType("TCP");
//                    }
//                    if (port.getPortType() == PortType.TLS) {
//                        infraService.setTlsType(true);
//                    }
//                    infraService.setVendor(MetaInfraVendor.CreateInfraVendorByService(service.getServiceName()));
//                    this.infraServiceDAO.save(infraService);
//
//                    Infra infraByService = Infra.CreateInfraByType(infraService.getId(), InfraService.class);
//                    this.infraDAO.save(infraByService);
//
//                    if(service.isTarget()) {
//                        Target targetService = new Target();
////                        targetService.setInfra(infraByService);
////                        targetService.setProbe(probe);
//                        this.targetDAO.save(targetService);
//                    }
//
//                }
//
//            }
//
//
//        }
//
//    }
}
