package com.loafle.overflow.module.apikey.service;

import com.loafle.overflow.module.apikey.model.ApiKey;
import com.loafle.overflow.module.domain.model.Domain;
import com.loafle.overflow.spring.AppConfigTest;
import org.junit.Assert;
import org.junit.Ignore;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

import static org.junit.Assert.*;

/**
 * Created by snoop on 17. 6. 28.
 */
@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(classes = {AppConfigTest.class})
public class ApiKeyServiceTest {

    @Autowired
    private ApiKeyService apiKeyService;

    @Ignore
    @Test
    public void regist() throws Exception {

        ApiKey apiKey = new ApiKey();

        apiKey.setApiKey("70124b775bd511e7b059080027658d13");

        Domain domain = new Domain();
        domain.setId(1);

        apiKey.setDomain(domain);

        this.apiKeyService.regist(apiKey);


        Assert.assertNotEquals(apiKey.getId(), 0);
    }

    @Ignore
    @Test
    public void check() throws Exception {

//        ApiKey apiKey = this.apiKeyDAO.findByApiKey("52abd6fd57e511e7ac52080027658d13");

        regist();

        boolean result=  this.apiKeyService.check("70124b775bd511e7b059080027658d13");

        Assert.assertNotEquals(result, false);
    }

    @Ignore
    @Test
    public void findByDomain() {

        Domain domain = new Domain();
        domain.setId(1);

        ApiKey apiKey = this.apiKeyService.readByDomain(domain);

        Assert.assertNotEquals(apiKey, null);

    }

}